package com.ekexiu.console.system.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.orm.annotation.dao.method.operator.Delete;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;

import com.ekexiu.console.system.dao.RightDao;
import com.ekexiu.console.system.po.SysRight;

@Path("/sys/right")
public class RightService {

	@Autowrie
	private RightDao rightDao;

	public RightDao getRightDao() {
		return rightDao;
	}

	public void setRightDao(RightDao rightDao) {
		this.rightDao = rightDao;
	}
	
	

	@Get
	@Path("/all")
	public List<SysRight> query(@JdbcConn Connection con) throws SQLException {
		return this.rightDao.query(con);
	}

	@Get
	@Path("/type/{type}")
	public List<SysRight> queryByType(@JdbcConn Connection con, @PathVar String type) throws SQLException {
		return this.rightDao.query(con, type);
	}

	@Get
	@Path("/id/{id}")
	public SysRight queryById(@JdbcConn Connection con, @PathVar int id) throws SQLException {
		return this.rightDao.query(con, id);
	}

	@Post
	@Path()
	public void insert(@JdbcConn(true) Connection con, SysRight right) throws SQLException {
		this.rightDao.insert(con, right);
	}

	@Put
	@Path()
	public void update(@JdbcConn(true) Connection con, @RequestBody SysRight right) throws SQLException {
		this.rightDao.insert(con, right);
	}

	@Path("/{id}")
	@Delete
	public void delete(@JdbcConn(true) Connection con, @PathVar int id) throws SQLException {
		this.rightDao.delete(con, id);
	}

}
