package com.ekexiu.console.system.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;

import com.ekexiu.console.system.dao.SysResourceDao;
import com.ekexiu.console.system.po.SysResource;
import com.ekexiu.console.system.vo.ConsoleAuthUser;

@Path("/sys/resource")
public class SysResourceService {
	
	@Autowrie
	private SysResourceDao sysResourceDao;

	public SysResourceDao getSysResourceDao() {
		return sysResourceDao;
	}

	public void setSysResourceDao(SysResourceDao sysResourceDao) {
		this.sysResourceDao = sysResourceDao;
	}
	
	@Get
	@Path("/all")
	public List<SysResource> query(@JdbcConn Connection con)throws SQLException{
		return this.sysResourceDao.query(con);
	}
	
	@Post
	@Path
	public void insert(@JdbcConn(true) Connection con,SysResource sres)throws SQLException{
		this.sysResourceDao.insert(con, sres);
	}
	
	@Put
	@Path
	public void update(@JdbcConn(true) Connection con,SysResource sres) throws SQLException{
		this.sysResourceDao.update(con, sres);
	}
	@Delete
	@Path("/{id}")
	public void delete(@JdbcConn(true) Connection con ,@PathVar String id)throws SQLException{
		this.sysResourceDao.delete(con, id);
	}
	
	@Get
	@Path("/byLoginUser")
	public List<SysResource> query(@JdbcConn Connection con,@LoginUser ConsoleAuthUser user )throws SQLException{
		List<SysResource> ret = new ArrayList<SysResource>();
		for(SysResource res:this.query(con)){
			if(user.hasAuthority(res.getAuthRight())){
				ret.add(res);
			}
		}
		return ret;
	}
}
